Logistic Regression
-------------------

Wagesbin <- Wagesdata[,-6]
Wagesbin$score[Wagesdata$WAGE<=median(Wagesdata$WAGE)] <- 0
Wagesbin$score[Wagesdata$WAGE>median(Wagesdata$WAGE)] <- 1
Wagesbin$score <- as.factor(Wagesbin$score)
median(Wagesdata$WAGE)

par(mfrow=c(1,2))
cdplot(score~AGE,data=Wagesbin)
cdplot(score~EXP,data=Wagesbin)
par(mfrow=c(1,1))

Wagesrl.mod1<- glm(score~EDUC,data=Wagesbin,family=binomial())
summary(Wagesrl.mod1)
Wagesrl.mod<- glm(score~.,data=Wagesbin,family=binomial())
summary(Wagesrl.mod)
exp(coef(Wagesrl.mod)["SEX1"])
confint(Wagesrl.mod,parm="SEX1")

Wagesrl_dev<- deviance(Wagesrl.mod)
Wagesrl_dev
Wagesrl.mod0<- glm(score~1,data=Wagesbin,family=binomial())
LRstat<- anova(Wagesrl.mod0,Wagesrl.mod)
LRstat

pearson_chisq<-sum(residuals(Wagesrl.mod,type='pearson')^2)
pearson_chisq

library(ResourceSelection)
Wagesrl_hl<- hoslem.test(Wagesbin$score,fitted(Wagesrl.mod))
Wagesrl_hl

influence.measures(Wagesrl.mod)

library(ROCR)
fit<-fitted(Wagesrl.mod)
fr <- data.frame(fit)
pred <- prediction(fr$fit,Wagesbin$score)
perf <- performance(pred, "sens", "fpr")
plot(perf)
abline(0,1)
perf <- performance(pred, "auc")
perf@y.values[[1]]

library(car)
Aircraft_data<- read.table(file.choose(),header=TRUE)
response<- cbind(Aircraft_data$Nbfail,Aircraft_data$Nbsurv)
Aircraft_mod<- glm(response~Load, data =Aircraft_data,family = binomial())
Aircraft_mod

Wagesmultinom <- Wagesdata[,-6]
Wagesmultinom$score3[Wagesdata$WAGE<=6] <- 1
Wagesmultinom$score3[Wagesdata$WAGE>6 & Wagesdata$WAGE<=10] <- 2
Wagesmultinom$score3[Wagesdata$WAGE>10] <- 3
Wagesmultinom$score3 <- as.factor(Wagesmultinom$score3)

library(nnet)
ajustmod<- multinom(Wagesmultinom$score3~.,data=Wagesmultinom)
ajustmod

library(mlogit)
Wagesmultdata <- mlogit.data(Wagesmultinom, shape = "wide", choice ="score3")
#ajustmod0<- mlogit(Wagesmultinom$score3~ 0 | EDUC+SOUTH+SEX+EXP+UNION+AGE+RACE+OCCUP+SECTOR+MARR , data = Wagesmultdata)
ajustmod0

library(MASS)
ajust_ord<- polr(score3~.,data=Wagesmultinom)
ajust_ord








###############################
### Script for discrimation between stars
### and quasars using binary logistic regression
library(car)
library(ROCR)
library(leaps)
######## data set given in the text before this script
######## 20 individuals and INC
######## can be saved as a txt file and read by read.table
###### read file data set
Quasarsdata<- read.table(file.choose(),header=TRUE)
###### new dataframe without the last individual
Quasarsdata1<- Quasarsdata[1:20,]
###### create the response variable
Quasarsdata1$Objet1<- rep(c(1,0),c(10,10))
###### distribution of col1-col4 along with response variable
par(mfrow=c(2,2))
plot(Quasarsdata1$Objet1,Quasarsdata1$col1,ylab="col1", xlab="1=star 0=quasar")
plot(Quasarsdata1$Objet1,Quasarsdata1$col2,ylab="col2", xlab="1=star 0=quasar")
plot(Quasarsdata1$Objet1,Quasarsdata1$col3,ylab="col3", xlab="1=star 0=quasar")
plot(Quasarsdata1$Objet1,Quasarsdata1$col4,ylab="col4", xlab="1=star 0=quasar")
par(mfrow=c(1,1))

par(mfrow=c(2,2))
boxplot(col1 ~ Objet1,data=Quasarsdata1,xlab="1=star 0=quasar",ylab="col1")
boxplot(col2 ~ Objet1,data=Quasarsdata1,xlab="1=star 0=quasar",ylab="col2")
boxplot(col3 ~ Objet1,data=Quasarsdata1,xlab="1=star 0=quasar",ylab="col3")
boxplot(col4 ~ Objet1,data=Quasarsdata1,xlab="1=star 0=quasar",ylab="col4")
par(mfrow=c(1,1))


###### complete model fitting
Quasars_reg0<- glm(Objet1~ .-Objet , family=binomial(link=logit),data=Quasarsdata1)
summary(Quasars_reg0)
###### investigate correlations and collinearity
XX<- cbind(Quasarsdata1$col1,Quasarsdata1$col2,Quasarsdata1$col3,Quasarsdata1$col4)
cor(XX)
vif(Quasars_reg0)
###### provide pi_hat(xb_i)
predict(Quasars_reg0,type="response")
###### constant model fitting
Quasars_regct<- glm(Objet1~ 1 , family=binomial(link=logit),data=Quasarsdata1)
summary(Quasars_regct)
###### Global test
##comparison by LR test
LR<-deviance(Quasars_regct)-deviance(Quasars_reg0)
LR
1-pchisq(LR,4)
###### Backward procedure with step function
Quasars_stepb<- step(Quasars_reg0,data=Quasarsdata1,direction="backward")
summary(Quasars_stepb)
###### Forward procedure with step function
Quasars_reg_ct<- glm(Objet1~ 1, family=binomial(link=logit),data=Quasarsdata1)
Quasars_stepf<- step(Quasars_reg_ct,scope=list(lower=~1,upper=Quasars_reg0),direction="forward")
summary(Quasars_stepf)
###### Exhaustive procedure with regsubsets
b<-regsubsets(Objet1~ col1+ col2+col3+col4,data=Quasarsdata1,nbest=1)
summary(b)
###### The best model with 2 variables
Quasars_reg24<- glm(Objet1~ col2+col4 , family=binomial(link=logit),data=Quasarsdata1)
summary(Quasars_reg24)
###### Graphical representation in (col2,col4)
plot(Quasarsdata1$col2,Quasarsdata1$col4,xlab="col2", ylab="col4",
     pch=19,text(Quasarsdata1$col2,Quasarsdata1$col4,labels=Quasarsdata1$Objet,cex =0.7,adj=c(0,-0.5)))
Coefline0<- -Quasars_reg24$coeff[1]/Quasars_reg24$coeff[3]
Coefline0
Coefline1<- -Quasars_reg24$coeff[2]/Quasars_reg24$coeff[3]
Coefline1
abline(Coefline0,Coefline1)
###### Predict INC individual and put in the graph
Q_new<- Quasarsdata[21,]
pred24<- predict(Quasars_reg24,Q_new,se.fit=TRUE,type="response")
pred24
points(Q_new[3],Q_new[5],text(Q_new[3],Q_new[5],labels ="INC",cex =0.7,adj=c(0,-0.5),col="red"),col="red")
###### Roc curve and AUC model (col2,col4)32 The Title of this Volume
fit<-fitted(Quasars_reg24)
fr <- with(data=Quasarsdata1,data.frame(fit,Objet1))
pred <- prediction(fr$fit, fr$Objet1)
perf <- performance(pred, "sens", "fpr")
plot(perf)
perf <- performance(pred, "auc")
perf@y.values[[1]]
###### Complement : using the complete model
###### Roc curve and AUC complete model
Quasars_reg_f<- glm(Objet1~ col1 + col2+ col3+ col4, family=binomial(link=logit),data=Quasarsdata1)
summary(Quasars_reg_f)
pred_f<- predict(Quasars_reg_f,Q_new,se.fit=TRUE,type="response")
pred_f
fit<-fitted(Quasars_reg_f)
fr <- with(data=Quasarsdata1,data.frame(fit,Objet1))
pred <- prediction(fr$fit, fr$Objet1)
perf <- performance(pred, "sens", "fpr")
plot(perf)
perf <- performance(pred, "auc")
perf@y.values[[1]]
##################################


