Multiple Linear Regression
--------------------------

Wagesdata <- read.table("./Data/Wages.txt", header=T, quote="\"")


Wagesdata$OCCUP <- as.factor(Wagesdata$OCCUP)
Wagesdata$SECTOR <- as.factor(Wagesdata$SECTOR)
Wagesdata$SOUTH <- as.factor(Wagesdata$SOUTH)
Wagesdata$RACE <- as.factor(Wagesdata$RACE)
Wagesdata$MARR <- as.factor(Wagesdata$MARR)
Wagesdata$SEX <- as.factor(Wagesdata$SEX)
Wagesdata$UNION <- as.factor(Wagesdata$UNION)
colnames(model.matrix(~ Wagesdata$OCCUP))

Wages.mod <- lm(WAGE~ .,data=Wagesdata)
Wages.mod
model.matrix(Wages.mod)

confint(lm(WAGE~ .,data=Wagesdata))

Wages.mod0 <- lm(WAGE ~ 1, data=Wagesdata)
anova(Wages.mod,Wages.mod0)

summary(Wages.mod)

Wages.mod1 <- update(Wages.mod,.~ .-SECTOR)
anova(Wages.mod1,Wages.mod)
Wages_stepb <- step(Wages.mod,data=Wagesdata,direction="backward")
Wages.mod0 <- lm(WAGE ~ 1,data=Wagesdata)
Wages_stepf <- step(Wages.mod0, scope=list(lower=~1,upper=Wages.mod),direction="forward")

library(leaps)
b <- regsubsets(WAGE~.,data=Wagesdata,nbest=2,method="backward")
summary(b)
b <- regsubsets(WAGE~.,data=Wagesdata,nbest=2,method="exhaustive")
summary(b)

help(influence.measures)
rstudent(Wages.mod)
dffits(Wages.mod)
cooks.distance(Wages.mod)
plot(rstudent(Wages.mod))
plot(cooks.distance(Wages.mod))
plot(dffits(Wages.mod))
influenceIndexPlot(Wages.mod,vars=c("Studentized"),id.n=3)
influenceIndexPlot(Wages.mod,vars=c("Cook","hat"),id.n=3)

library(car)
Wages.mod2<- lm(WAGE~ EDUC + EXP +AGE ,data=Wagesdata)
vif(Wages.mod2)


