# Simple Linear Regression ----------------------------------------------

data(cars)
plot(cars,xlab="Speed (mph)",ylab="Stopping distance (ft)")
reg_cars <- lm(dist ~ speed, data = cars)
reg_cars
plot(cars,main="Stopping distance/speed", 
     xlab="Speed (mph)", ylab="Stopping distance (ft)")
abline(reg_cars)
confint(reg_cars)
confint(reg_cars,level=0.90)
summary(reg_cars)
anova(reg_cars)

library(RcmdrPlugin.HH)
ci.plot(reg_cars,main="95% confidence and prediction intervals for reg_cars")
new <- data.frame(speed<-seq(0,28,0.5))
predict(reg_cars,new,se.fit=TRUE)
pred.w.plim <- predict(reg_cars,new,interval = "prediction")
pred.w.clim <- predict(reg_cars,new,interval = "confidence")
plot(cars,xlab="speed",ylab="stopping distance",
     main="Confidence and Prediction Intervals",pch=20)
matplot(new$speed, cbind(pred.w.clim, pred.w.plim), 
        lty =c(1,2,2,1,3,3),type="l",
        ylab="stopping distance", add=TRUE,col=rep("black",6))

help(influence.measures)
rstudent(reg_cars)
dffits(reg_cars)
cooks.distance(reg_cars)
plot(rstudent(reg_cars))
plot(cooks.distance(reg_cars))
plot(dffits(reg_cars))
influenceIndexPlot(reg_cars,vars=c("Studentized"), id.n=3)
influenceIndexPlot(reg_cars,vars=c("Cook","hat"), id.n=3)

DataTomm <- read.table("./Data/DataTomm.txt", header=T, quote="\"")
op <- par(mfrow=c(2,3))
attach(DataTomm)
yax1 <- lm(ya ~ x1);plot(x1,ya,main="(a)");abline(yax1)
ybx1 <- lm(yb ~ x1);plot(x1,yb,main="(b)");abline(ybx1)
ycx1 <- lm(yc ~ x1);plot(x1,yc,main="(c)");abline(ycx1)
ydx1 <- lm(yd ~ x1);plot(x1,yd,main="(d)");abline(ydx1)
yexe <- lm(ye ~ xe);plot(xe,ye,main="(e)");abline(yexe)
detach(DataTomm)
par(op)
summary(yax1)
summary(ybx1)
summary(ycx1)
summary(ydx1)
summary(yexe)




library(datasets)
data(pressure)
pp <- pressure$pressure
pt <- pressure$temperature
par(bg="cornsilk",pch=21)
plot(pt,log(pp),bg="red")
reg_press <- lm(pt ~ log(pp))
abline(reg_press)
confint(reg_press)
summary(reg_press)
anova(reg_press)
library(RcmdrPlugin.HH)
hist(summary(reg_press)$residuals)


