Survival Analysis
-----------------

library(survival)
time<- c(6,6,6,6,7,9,10,10,11,13,16,17,19,20,22,23,25,32,32,34,35)
status<-c(1,1,1,0,1,0,1,0,0,1,1,0,0,0,1,1,0,0,0,0,0)
fit <- survfit(Surv(time, status) ~ 1,error="g",conf.type="plain")
plot(fit,ylab="Kaplan-Meier estimate and Confidence intervals (Greenwood)")
summary(fit)

myel_data <- read.table("myel_data.txt", header=T)
myel_data$platelet <- as.factor(myel_data$platelet)
myel_data$frac <- as.factor(myel_data$frac)
attach(myel_data)

myel_data$platelet<- as.factor(myel_data$platelet)
myel_data$frac<- as.factor(myel_data$frac)
myel_reg<-survreg(Surv(time,vstatus)~logbun+hgb+ platelet +age +logwbc +frac +logpbm +protein +scalc, dist='weibull',data=myel_data)
summary(myel_reg)


myel_stepb<- step(myel_reg,data=myel_data,direction="backward")
summary(myel_stepb)

myel_reg_min<- survreg(Surv(time,vstatus)~logbun+hgb,data=myel_data)
anova(myel_reg_min,myel_reg)

myel_cox<- coxph(Surv(time,vstatus)~logbun+hgb+platelet+ age+logwbc+frac+logpbm+protein+scalc,data=myel_data)
summary(myel_cox)

myel_cox_stepb<- step(myel_cox,data=myel_data,direction="backward")
summary(myel_cox_stepb)
myel_cox0<- coxph(Surv(time,vstatus)~1,data=myel_data)
myel_cox_stepf<- step(myel_cox0,scope=list(lower=~1,upper=myel_cox), direction="forward")
summary(myel_cox_stepf)

myel_cox_min<- coxph(Surv(time,vstatus)~logbun+hgb,data=myel_data)
anova(myel_cox_min,myel_cox)

detach(myel_data)
